<?php
// ----------------------------------------------------------------------
// Copyright (c) 2002-2004 Shawn McKenzie
// http://spidean.mckenzies.net
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------

function atThemeAddHeader()
{
    $runningconfig = atGetRunningConfig();
    extract($runningconfig);

    extract($style);

    if (isset($stylesheet)) {
        if (@file_exists($themepath.$stylesheet) && !@is_dir($themepath.$stylesheet)) {
            $head .= "<link rel=\"stylesheet\" href=\"".$themepath.$stylesheet."\" type=\"text/css\">\n";
        }
    }
    $head .= "\n<!--\n"
    ."************************** AT-Lite .8 ***************************\n"
    ."-->\n\n";

	if ($striphead) {
		$head .= "</head>\n\n";
	}
	echo $head;
}

function atThemeAddFooter()
{
    $runningconfig = atGetRunningConfig();
    extract($runningconfig);

    $footer = "\n<!--\n"
    ."************************** AT-Lite .8 ***************************\n"
    ."-->\n";

	echo $footer;
}

function atCompileRead($filename, $modifier="")
{
    $globalconfig = atGetGlobalConfig();
    extract($globalconfig);

    $oldmask = umask(0);

    $compiletime = date("mdyhis", @filemtime($incdir."atCommands.php"))
               . date("mdyhis", @filemtime($platformdir."atCommands.php"))
               . date("mdyhis", @filemtime($atdir."autotheme.cfg"));

    if (!@file_exists($compiledir.$compiletime)) {
        atCompileClear($compiledir);
        if ($handle = @fopen($compiledir.$compiletime, "w")) {
            fclose($handle);
        }	
        return false;
    }
    if (atIsLoggedIn()) {
        $user = 1;
    }
    else {
        $user = 0;
    }
    if (atIsAdminUser()) {
        $admin = 1;
    }
    else {
        $admin = 0;
    }
    $filetime = date("mdyhis", @filemtime("$filename"))
              . date("mdyhis", @filemtime($themepath."theme.cfg"));

    $filename = strtolower(preg_replace("/[^\w]*/", "", $thename.$user.$admin.$modifier.$filename.$filetime));

    if ($output = atTemplateRead($compiledir.$filename)) {
		return $output;
    }
    else {
        return false;
    }
}

function atCompileWrite($filename, $content, $modifier="")
{
    $globalconfig = atGetGlobalConfig();
    extract($globalconfig);

    $oldmask = umask(0);

    $compiletime = date("mdyhis", @filemtime($incdir."atCommands.php"))
               . date("mdyhis", @filemtime($platformdir."atCommands.php"))
               . date("mdyhis", @filemtime($atdir."autotheme.cfg"));

    if (atIsLoggedIn()) {
        $user = 1;
    }
    else {
        $user = 0;
    }
    if (atIsAdminUser()) {
        $admin = 1;
    }
    else {
        $admin = 0;
    }
    $filetime = date("mdyhis", @filemtime("$filename"))
              . date("mdyhis", @filemtime($themepath."theme.cfg"));

    $filepre = strtolower(preg_replace("/[^\w]*/", "", $thename.$user.$admin.$modifier.$filename));
    $filename = $filepre.$filetime;

    if ($handle = @opendir($compiledir)) {
       while (false !== ($file = @readdir($handle))) {
            if (false !== strpos($file, $filepre)) {
                @unlink($compiledir.$file);
            }
        }
        closedir($handle);
    }
    if ($handle = @fopen($compiledir.$filename, "w")) {
        fwrite($handle, $content);
	    fclose($handle);
    }
}

function atCompileClear()
{
	$compiledir = atAutoGetVar('compiledir');

    if ($handle = @opendir($compiledir)) {
            while (false !== ($file = @readdir($handle))) {
                @unlink($compiledir.$file);
            }
            closedir($handle);
    }
}

function atTemplateCompile($file, $striphead=1)
{
    $globalconfig = atGetGlobalConfig();
    extract($globalconfig);
    
    if (!$output = atCompileRead($file)) {
            $HTML = atTemplatePrep($file, $striphead);
            $output = atCommandReplace($HTML, $command);
            atCompileWrite($file, $output);
    }
    return $output;
}

?>
